/**
 ******************************************************************************
 **	t@C : sample.c
 **
 **	Tv       : 2֓|UqCg[X{bgTOPPERS/JSPpTvvO
 **
 ******************************************************************************
 **/
#include <s_services.h>
#include "sample.h"
#include "kernel_id.h"
#include "ecrobot_base.h"
#include "ecrobot_interface.h"
#include "balancer.h" /* |Uqpwb_t@C */

/* L̃p[^̓ZT/ɍ킹ă`[jOKv܂ */
#define GYRO_OFFSET  589 /* WCZTItZbgl(px0[deg/sec])  */
#define WHITE		 534 /* F̌ZTl */
#define BLACK		 674 /* F̌ZTl */

//*****************************************************************************
// TASK			: cyc0
// DESCRIPTION 	: 4msec periodical Task handler
//*****************************************************************************
void cyc0(VP_INT exinf)
{
	isig_sem(EVT_SEM);
}

//*****************************************************************************
// ^XN	: TaskMain
// Tv		: C^XN
//*****************************************************************************
void TaskMain(VP_INT exinf)
{
	signed char forward;      /* Oi: -100(i)`100(Oi)   */
	signed char turn;         /* 񖽗: -100()`100(E) */
	signed char pwm_L, pwm_R; /* E[^PWMo */
	signed char vecter = 0;

	ecrobot_set_light_sensor_active(NXT_PORT_S3);       /* ZTԐFLEDON */
	while (ecrobot_get_touch_sensor(NXT_PORT_S1) == 0){ /* ^b`ZTҋ@ */
		dly_tsk(10);
	}

	balance_init();						/* |Uq䏉 */
	nxt_motor_set_count(NXT_PORT_C, 0); /* [^GR[_Zbg */
	nxt_motor_set_count(NXT_PORT_B, 0); /* E[^GR[_Zbg */
	forward = 50;						/* Oi */
	sta_cyc(CYC0);
	while(1){
		if (ecrobot_get_light_sensor(NXT_PORT_S3) <= (WHITE + BLACK)/2)
			turn = 50;  /* E */
		else
			turn = -50; /*  */

		/* |Uq(forward = 0, turn = 0ŐÎ~oX) */
		balance_control(
			(float)forward,                              /* Oi                 */
			(float)turn,                                 /* 񖽗                   */
			(float)ecrobot_get_gyro_sensor(NXT_PORT_S4), /* WCZTl           */
			(float)GYRO_OFFSET,                          /* WCZTItZbgl */
			(float)nxt_motor_get_count(NXT_PORT_C),      /* [^]px[deg]      */
			(float)nxt_motor_get_count(NXT_PORT_B),      /* E[^]px[deg]      */
			(float)ecrobot_get_battery_voltage(),        /* obed[mV]           */
			&pwm_L,  /* [^PWMo͒l */
			&pwm_R); /* E[^PWMo͒l */
		nxt_motor_set_speed(NXT_PORT_C, pwm_L, 1); /* [^PWMo̓Zbg */
		nxt_motor_set_speed(NXT_PORT_B, pwm_R, 1); /* E[^PWMo̓Zbg */

		wai_sem(EVT_SEM);	/* 4MS҂ */
	}
}

//*****************************************************************************
// ^XN	: TaskDisp
// Tv		: \^XN
//*****************************************************************************
void TaskDisp(VP_INT exinf)
{
	show_splash_screen();
	ecrobot_init_nxtstate();
	ecrobot_init_sensors();
	show_main_screen();
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	act_tsk(TASK0);
	while(1){
		ecrobot_poll_nxtstate();
		ecrobot_get_sonar_sensor(NXT_PORT_S2);
		ecrobot_status_monitor("sample JSP"); /* LCD display */
		dly_tsk(40U); /* 40msec wait */
	}
}

