/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *  ץåȰ¸ꥢIO⥸塼OAKS16-mini
 */

/*
 *  KD30 ѻ( USE_KD30 ) KD30  UART1 Ѥ뤿ᡤ
 *  ꥢIO⥸塼ưʤ
 *  UART0 ѤϤ뤬OILե˵ܤƤߥȥ꡼
 *  ֹ򥳥ѥ륪ץ( USE_KD30 )ؤ褤ˡʤᡤ
 *  UART0 ѤϹԤʤ
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_


#include "kernel.h"
/*#include "sfrm16c26.h"*/


/*
 *  ꥢݡȤγߥ٥
 */
#define CFG_INTLVL_SERIAL_RX	(UINT8)0x06		/* 󥽡ݡȼ	*/

/*
 *  ꥢݡȤΥܡ졼
 *
 *  CFG_BRG_SERIAL ѹǥܡ졼Ȥѹǽ
 */
#define	BRG_SERIAL_19200	(UINT8)64/* 20000000/{(UxBRG+1)*16} = 19200	*/
#define	BRG_SERIAL_38400	(UINT8)31/* 20000000/{(UxBRG+1)*16} = 38400	*/
#define	CFG_BRG_SERIAL		BRG_SERIAL_38400


#ifndef _MACRO_ONLY
/*
 *  ƥϥ⥸塼ؿץȥ
 */
extern void	InitHwSerial( void );

/*
 *  ƥϥ⥸塼ߴؿץȥ
 */
extern void	TermHwSerial( void );

/*
 *  ƤӻؤƥȤǤʸؿץȥ
 */
extern void	PutHwChar( UINT8 character );

/*
 *  Хåؿ
 */
extern void	RxSerialInt( UINT8 character );

/*
 *  ߳ǧؿ
 */
extern void RxHwSerialInt( void );

/*
 *  BLUETOOTHѥåȤΥեå
 */
extern void FlushSerial(void);


#endif /* _MACRO_ONLY */

#endif /* _HW_SERIAL_H_ */
